#version 330

uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;
uniform vec3 cameraPosition;

uniform float heightMultiplier;
uniform vec3 lightLoc;

// attribute buffers
in vec3 position;
in vec3 color;
in vec2 uv;

// aka varying's
out vec2 vUv;
out vec3 fL;
out vec3 fH;
out vec3 vColor;
		  
void main(){	  
	vec4 pos = vec4(position, 1.0);

	fL = normalize(lightLoc-pos.xyz);
	vec3 E = normalize(-pos.xyz);
	fH = normalize(fL + E);
	
	gl_Position = projectionMatrix*modelViewMatrix*vec4(position.x, position.y * heightMultiplier, position.z, 1.0);

	// pass uv and color to frag shader
	vUv = uv;
	vColor = color.xyz;
}